/**
***     Copyright (C) 2003 SophiaCradle, Inc.
***     All rights reserved.
**/

//
//  ̃\[XR[h̃G[͂xłB
//  HIȎgpɓĂ̓G[苭邱Ƃ]܂łB
//

#include "AEEModGen.h"      // W[ C^[tF[X̐錾
#include "AEEAppGen.h"      // Avbg C^[tF[X̐錾
#include "AEEStdLib.h"      // DBGPRINTF p̃CN[h
#include "AEEFile.h"        // IFileMgr  IFile C^[tF[X̐錾
#include "filesystem.bid"   // NX ID t@C̃CN[h

// Filesystem Avbg\
typedef struct FilesystemApplet {
    AEEApplet       a;      // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱

    // 񓯊ǂݍݗp̃o
    IFileMgr*       filemgr;
    IFile*          file;
    char            buffer[128];
} FilesystemApplet;

// O錾
        int         AEEClsCreateInstance(AEECLSID,IShell*,IModule*,void**);
static  boolean     Filesystem_HandleEvent(FilesystemApplet*,AEEEvent,uint16,uint32);
static  boolean     Filesystem_OnAppStart(FilesystemApplet*);
static  boolean     Filesystem_OnAppStop(FilesystemApplet*);
static  boolean     Filesystem_OnAppResume(FilesystemApplet*);
static  boolean     Filesystem_OnAppSuspend(FilesystemApplet*);
static  boolean     Filesystem_OnAppKey(FilesystemApplet*,uint16);
static  void        Filesystem_CreateRemoveDirectory(FilesystemApplet*);
static  void        Filesystem_CreateDirectoryRecursive(FilesystemApplet*);
static  void        Filesystem_GetInfoRecursive(FilesystemApplet*,const char*);
static  void        Filesystem_RmDirRecursive(FilesystemApplet*,const char*);
static  void        Filesystem_CreateCloseFile(FilesystemApplet*);
static  void        Filesystem_OpenCloseFile(FilesystemApplet*);
static  void        Filesystem_GetInfoFromIFile(FilesystemApplet*);
static  void        Filesystem_GetInfoFromIFileMgr(FilesystemApplet*);
static  void        Filesystem_FileRead(FilesystemApplet*);
static  void        Filesystem_FileReadAsync(FilesystemApplet*);
static  void        Filesystem_ReadCallback(FilesystemApplet*);
static  void        Filesystem_FileWrite(FilesystemApplet*);
static  void        Filesystem_ClearScreen(FilesystemApplet*);
static  void        Filesystem_Done(FilesystemApplet*);

//
//  Avbg쐬ƂɌĂяo܂
//
int AEEClsCreateInstance(AEECLSID id,IShell* shell,IModule* module,void** applet)
{
    *applet = NULL;
    if (id == AEECLSID_FILESYSTEM) {
        if (AEEApplet_New(sizeof(FilesystemApplet),id,shell,module,
                          (IApplet**)applet,(AEEHANDLER)Filesystem_HandleEvent,NULL)) {
            return(SUCCESS);
        }
    }
    return(EFAILED);
}

//
//  Cxg nh
//
static boolean Filesystem_HandleEvent(FilesystemApplet* app,AEEEvent event,uint16 p16,uint32 p32)
{
    switch (event) {
        case EVT_APP_START:
            return Filesystem_OnAppStart(app);

        case EVT_APP_STOP:
            return Filesystem_OnAppStop(app);

        case EVT_APP_RESUME:
            return Filesystem_OnAppResume(app);

        case EVT_APP_SUSPEND:
            return Filesystem_OnAppSuspend(app);

        case EVT_KEY:
            return Filesystem_OnAppKey(app,p16);

        default:
            break;
    }
    return(FALSE);
}

//
//  AvbgJnƂɌĂяo
//
static boolean Filesystem_OnAppStart(FilesystemApplet* app)
{
    Filesystem_ClearScreen(app);
    return(TRUE);
}

//
//  AvbgIƂɌĂяo
//
static boolean Filesystem_OnAppStop(FilesystemApplet* app)
{
    return(TRUE);
}

//
//  AvbgĊJƂɌĂяo
//
static boolean Filesystem_OnAppResume(FilesystemApplet* app)
{
    Filesystem_ClearScreen(app);
    return(TRUE);
}

//
//  AvbgfƂɌĂяo
//
static boolean Filesystem_OnAppSuspend(FilesystemApplet* app)
{
    return(TRUE);
}

//
//  L[ꂽƂɌĂяo
//
static boolean Filesystem_OnAppKey(FilesystemApplet* app,uint16 key)
{
    switch (key) {
        case AVK_0:
            Filesystem_ClearScreen(app);
            return(TRUE);

        case AVK_1:
            Filesystem_CreateRemoveDirectory(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_2:
            Filesystem_CreateDirectoryRecursive(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_3:
            Filesystem_GetInfoRecursive(app,"");
            Filesystem_Done(app);
            return(TRUE);

        case AVK_4:
            Filesystem_RmDirRecursive(app,"target_dir");
            Filesystem_Done(app);
            return(TRUE);

        case AVK_5:
            Filesystem_CreateCloseFile(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_6:
            Filesystem_OpenCloseFile(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_7:
            Filesystem_GetInfoFromIFile(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_8:
            Filesystem_GetInfoFromIFileMgr(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_9:
            Filesystem_FileRead(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_STAR:
            Filesystem_FileReadAsync(app);
            Filesystem_Done(app);
            return(TRUE);

        case AVK_POUND:
            Filesystem_FileWrite(app);
            Filesystem_Done(app);
            return(TRUE);

        default:
            break;
    }
    return(FALSE);
}

//
//  fBNg쐬āAOύX̂A폜֐
//
static void Filesystem_CreateRemoveDirectory(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // fBNg̍쐬
    IFILEMGR_MkDir(filemgr,"new_dir");

    // O̕ύX
    IFILEMGR_Rename(filemgr,"new_dir","temp_dir");

    // fBNg̍폜
    IFILEMGR_RmDir(filemgr,"temp_dir");

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  [Kw̃fBNgċAIɍ쐬֐
//
static void Filesystem_CreateDirectoryRecursive(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // PKwڂ̃fBNg쐬
    IFILEMGR_MkDir(filemgr,"1st_dir");

    // QKwڂ̃fBNg쐬
    IFILEMGR_MkDir(filemgr,"1st_dir/2nd_dir");

    // RKwڂ̃fBNg쐬
    IFILEMGR_MkDir(filemgr,"1st_dir/2nd_dir/3rd_dir");

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  SẴfBNgċAIɏ񂵂ď擾֐
//
static void Filesystem_GetInfoRecursive(FilesystemApplet* app,const char* name)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    FileInfo        info;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // 񋓂fBNgpɏ
    if (IFILEMGR_EnumInit(filemgr,name,TRUE) == SUCCESS) {

        // ̗vf擾
        while (IFILEMGR_EnumNext(filemgr,&info)) {

            // fBNg̏o
            DBGPRINTF("Directory found : %s",info.szName);

            // fBNg̒ċNIɏ
            Filesystem_GetInfoRecursive(app,info.szName);
        }

        // 񋓂t@Cpɏ
        if (IFILEMGR_EnumInit(filemgr,name,FALSE) == SUCCESS) {

            // ̗vf擾
            while (IFILEMGR_EnumNext(filemgr,&info)) {

                // t@C̏o
                DBGPRINTF("File found : %s",info.szName);
            }
        }
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  głȂfBNg폜֐
//
static void Filesystem_RmDirRecursive(FilesystemApplet* app,const char* name)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    FileInfo        info;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // 񋓂fBNgpɏ
    if (IFILEMGR_EnumInit(filemgr,name,TRUE) == SUCCESS) {

        // ̗vf擾
        while (IFILEMGR_EnumNext(filemgr,&info)) {

            // fBNg̒ċNIɏ
            Filesystem_RmDirRecursive(app,info.szName);
        }

        // 񋓂t@Cpɏ
        if (IFILEMGR_EnumInit(filemgr,name,FALSE) == SUCCESS) {

            // ̗vf擾
            while (IFILEMGR_EnumNext(filemgr,&info)) {

                // t@C̍폜
                IFILEMGR_Remove(filemgr,info.szName);
            }
        }

        // fBNg̍폜
        IFILEMGR_RmDir(filemgr,name);
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  t@CVKɍ쐬āAI[v̂AN[Y֐
//
static void Filesystem_CreateCloseFile(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    IFile*          file;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // t@C̐VKI[v
    file = IFILEMGR_OpenFile(filemgr,"sample.txt",_OFM_CREATE);

    if (file != NULL) {

        // t@C̃N[Y
        IFILE_Release(file);
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  t@C݂ꍇ̓I[vAt@C
//  Ȃꍇ͐VKɍ쐬ăI[v̂AN[Y֐
//
static void Filesystem_OpenCloseFile(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    IFile*          file;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // t@C̃I[v
    file = IFILEMGR_OpenFile(filemgr,"sample.txt",_OFM_READWRITE);

    // t@C݂Ȃꍇ
    if (file == NULL) {

        // t@C̐VKI[v
        file = IFILEMGR_OpenFile(filemgr,"sample.txt",_OFM_CREATE);
    }

    if (file != NULL) {

        // t@C̃N[Y
        IFILE_Release(file);
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  IFile C^[tF[Xgpăt@C̏擾֐
//
static void Filesystem_GetInfoFromIFile(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    IFile*          file;
    FileInfo        info;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // t@C̃I[v
    file = IFILEMGR_OpenFile(filemgr,"sample.txt",_OFM_READ);

    if (file != NULL) {

        // t@C̎擾
        IFILE_GetInfo(file,&info);

        // t@C̏o
        DBGPRINTF("name : %s, size : %06d bytes",info.szName,info.dwSize);

        // t@C̃N[Y
        IFILE_Release(file);
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  IFileMgr C^[tF[Xgpăt@C̏擾֐
//
static void Filesystem_GetInfoFromIFileMgr(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    FileInfo        info;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // t@C̎擾
    IFILEMGR_GetInfo(filemgr,"sample.txt",&info);

    // t@C̏o
    DBGPRINTF("name : %s, size : %06d bytes",info.szName,info.dwSize);

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  ubLOŃt@Cf[^ǂݍފ֐
//
static void Filesystem_FileRead(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    IFile*          file;
    char            buffer[128];
    int             size;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // t@C̐VKI[v
    file = IFILEMGR_OpenFile(filemgr,"sample.txt",_OFM_READ);

    if (file != NULL) {

        // t@C̃f[^̓ǂݍ
        size = IFILE_Read(file,buffer,sizeof(buffer) - 1);

        if (size > 0) {

            // ǂݍ񂾃f[^̏o
            buffer[size] = '\0';
            DBGPRINTF("read : %s",buffer);
        }

        // t@C̃N[Y
        IFILE_Release(file);
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  mubLOŃt@Cf[^ǂݍފ֐
//
static void Filesystem_FileReadAsync(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&app->filemgr);

    // t@C̐VKI[v
    app->file = IFILEMGR_OpenFile(app->filemgr,"sample.txt",_OFM_READ);

    if (app->file != NULL) {

        // R[obN̓o^
        IFILE_Readable(app->file,(PFNNOTIFY)Filesystem_ReadCallback,app);
    }
    else {

        // IFileMgr C^[tF[X̔j
        IFILEMGR_Release(app->filemgr);
    }
    return;
}

//
//  mubLOǂݍݗp̃R[obN֐
//
static void Filesystem_ReadCallback(FilesystemApplet* app)
{
    int             size;

    // t@C̃f[^̓ǂݍ
    size = IFILE_Read(app->file,app->buffer,sizeof(app->buffer) - 1);

    // ʂ̔
    switch (size) {
        case AEE_STREAM_WOULDBLOCK:  // ubLO

            // R[obN̓o^
            //
            // AEE_STREAM_WOULDBLOCK  IAStream Œ`Ă܂A
            // IFile ł͔Ȃ悤łB
            IFILE_Readable(app->file,(PFNNOTIFY)Filesystem_ReadCallback,app);
            break;

        case 0:  // s

            // t@C̃N[Y
            IFILE_Release(app->file);

            // IFileMgr C^[tF[X̔j
            IFILEMGR_Release(app->filemgr);
            break;

        default:  // ̑
            if (size > 0) {

                // ǂݍ񂾃f[^̏o
                app->buffer[size] = '\0';
                DBGPRINTF("read : %s",app->buffer);

                // t@C̃N[Y
                IFILE_Release(app->file);

                // IFileMgr C^[tF[X̔j
                IFILEMGR_Release(app->filemgr);
            }
            break;
    }
    return;
}

//
//  t@Cփf[^ފ֐
//
static void Filesystem_FileWrite(FilesystemApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IFileMgr*       filemgr;
    IFile*          file;
    char            buffer[]    = "If you didn't know about the FRAMEWORK for BREW,"
                                  " the development of your products will be in the deadline.";

    // IFileMgr C^[tF[X̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_FILEMGR,(void*)&filemgr);

    // t@C̐VKI[v
    file = IFILEMGR_OpenFile(filemgr,"sample.txt",_OFM_CREATE);

    if (file != NULL) {

        // t@Cւ̃f[^̏
        IFILE_Write(file,buffer,sizeof(buffer) - 1);

        // t@C̃N[Y
        IFILE_Release(file);
    }

    // IFileMgr C^[tF[X̔j
    IFILEMGR_Release(filemgr);
    return;
}

//
//  ʂԂɖ߂֐
//
static void Filesystem_ClearScreen(FilesystemApplet* app)
{
    const AECHAR    str0[]  = {'0',':','C','l','e','a','r',' ','s','c','r','e','e','n','\0'};
    const AECHAR    str1[]  = {'1',':','C','r','e','a','t','e',' ','R','e','m','o','v','e',' ','D','i','r','\0'};
    const AECHAR    str2[]  = {'2',':','C','r','e','a','t','e',' ','D','i','r',' ','R','e','c','u','r','s','i','v','e','\0'};
    const AECHAR    str3[]  = {'3',':','G','e','t',' ','I','n','f','o',' ','R','e','c','u','r','s','i','v','e','\0'};
    const AECHAR    str4[]  = {'4',':','R','e','m','o','v','e',' ','D','i','r',' ','R','e','c','u','r','s','i','v','e','\0'};
    const AECHAR    str5[]  = {'5',':','C','r','e','a','t','e',' ','C','l','o','s','e',' ','F','i','l','e','\0'};
    const AECHAR    str6[]  = {'6',':','O','p','e','n',' ','C','l','o','s','e',' ','F','i','l','e','\0'};
    const AECHAR    str7[]  = {'7',':','G','e','t',' ','I','n','f','o',' ','I','F','i','l','e','\0'};
    const AECHAR    str8[]  = {'8',':','G','e','t',' ','I','n','f','o',' ','I','F','i','l','e','M','g','r','\0'};
    const AECHAR    str9[]  = {'9',':','F','i','l','e',' ','R','e','a','d','\0'};
    const AECHAR    strS[]  = {'*',':','F','i','l','e',' ','R','e','a','d',' ','A','s','y','n','c','\0'};
    const AECHAR    strP[]  = {'#',':','F','i','l','e',' ','W','r','i','t','e','\0'};
    IShell*         shell   = app->a.m_pIShell;
    IDisplay*       display = app->a.m_pIDisplay;
    AEERect         rect;
    AEEDeviceInfo   info;

    // foCX擾
    ISHELL_GetDeviceInfo(shell,&info);

    // `悷`ݒ
    rect.x = 0;
    rect.y = 0;
    rect.dx = info.cxScreen;
    rect.dy = IDISPLAY_GetFontMetrics(display,AEE_FONT_NORMAL,NULL,NULL);

    // ʂNA
    IDISPLAY_ClearScreen(display);

    // `
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str0,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str1,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str2,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str3,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str4,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str5,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str6,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str7,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str8,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str9,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,strS,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,strP,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);

    // ʍXV
    IDISPLAY_Update(display);
    return;
}

//
//  IƂʂɕ\֐
//
static void Filesystem_Done(FilesystemApplet* app)
{
    const AECHAR    str[]   = {'D','o','n','e','.','.','.','\0'};
    IDisplay*       display = app->a.m_pIDisplay;

    // ʂNA
    IDISPLAY_ClearScreen(display);

    // `
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str,-1,0,0,NULL,IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);

    // ʍXV
    IDISPLAY_Update(display);
    return;
}
